d={}
s = tostring(d)
math.randomseed(tonumber(string.sub(s, string.find(s, " ") + 1, string.len(s)), 16))
mainhue = 0

function inside(x,a,b)
	return  ((x>=a) and (x<b))
end
function angle(ang)
	if ang<0 then return(ang+360)
	else return(ang%360) end
end
function hsv(hue, saturation, value)
	local r1, g1, b1
	local chroma=value*saturation
	local hues=hue/60
	local x=chroma*(1-math.abs(hues%2-1))
	if     inside(hues,0,1) then
		r1=chroma
		g1=x
		b1=0
	elseif inside(hues,1,2) then
		r1=x
		g1=chroma
		b1=0
	elseif inside(hues,2,3) then
		r1=0
		g1=chroma
		b1=x
	elseif inside(hues,3,4) then
		r1=0
		g1=x
		b1=chroma
	elseif inside(hues,4,5) then
		r1=x
		g1=0
		b1=chroma
	elseif hues>=5 then
		r1=chroma
		g1=0
		b1=x
	else
		r1=0
		g1=0
		b1=0
	end
	local m=value-chroma
	return {r=math.ceil((r1+m)*255), g=math.ceil((g1+m)*255), b=math.ceil((b1+m)*255)}
end
r17=math.random(0,100)
r18=math.random(0,100)
function randomhuecolors()
	--mainhue=30*math.random(0,11)
	return fif(r18<80,fif(r17<50,{hsv(angle(mainhue-60),1,1),hsv(angle(mainhue-30),1,1),hsv(mainhue,1,1),hsv(angle(mainhue+30),1,1),hsv(angle(mainhue+60),1,1)},{hsv(angle(mainhue+60),1,1),hsv(angle(mainhue+30),1,1),hsv(mainhue,1,1),hsv(angle(mainhue-30),1,1),hsv(angle(mainhue-60),1,1)}),fif(r17<50,{hsv(angle(mainhue-30),1,1),hsv(mainhue,1,1),hsv(angle(mainhue+30),1,1)},{hsv(angle(mainhue+30),1,1),hsv(mainhue,1,1),hsv(angle(mainhue-30),1,1)}))
end

jumping = PlayerCanJump()
function fif(test, if_true, if_false)
  if test then return if_true else return if_false end
end

hifi = GetQualityLevel() > 2 -- GetQualityLevel returns 1,2,or 3
function ifhifi(if_true, if_false)
  if hifi then return if_true else return if_false end
end
mainhue=30*math.random(0,11)
randgrey=math.random(1,11)
skinvars = GetSkinProperties()
trackWidth = skinvars["trackwidth"]
casual = trackWidth==16
doublevision = trackWidth==11.5
guitarhero = trackWidth==8

SetScene{
	glowpasses = 0,
	glowspread = 0,
	radialblur_strength = .5,
--	radialblur_strength = fif(jumping,2,0),
	watertype = 2,
	water = false,
	watertint = {r=11,g=11,b=11,a=11},
	watertexture = "transparent.png",
	towropes = jumping,
	airdebris_count = ifhifi(500,100),
	airdebris_density = ifhifi(10,2),
	useblackgrid=false,
	airdebris_count = ifhifi(1200,300),
	airdebris_density = ifhifi(40,12),
	airdebris_texture = fif(randgrey==2,"firework641.png","firework64.png"),
	airdebris_layer = 12,
	twistmode={curvescaler=1, steepscaler=.1} -- note: "cork" is the same as {curvescaler=1, steepscaler=1} and "cork_flatish" is the same as {curvescaler=1, steepscaler=.4}
}

SetPuzzleGraphics{
	usesublayerclone = false,
	puzzlematerial={
		texture = fif(randgrey==2,"tiles_sq2.png","tiles_sq.png"),
		shader = fif(ispuzzle, "VertexColorUnlitTintedAlpha", "DiffuseVertexColored")
	},
	puzzlematchmaterial={
		texture = "tilematch_sq.png",
		shader = "Particles/Additive"
	},
	puzzleflyupmaterial={
		texture = "transparent.png",
		shader = "Particles/Additive"
	}
}

SetBlocks{
	allow_mod_block_scaling = false,
	colorblocks=fif(randgrey==2,{
		mesh = "Color.obj",
		shader = "GlassBumpDistort_AddReflection",
		shadersettings ={
			_ReflectMultiply = .5,
			_FresnelPower = 3.5, -- 1.36,
			_Brightness = 3
		},
		colorMode="highway",
		Color={colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1},
		shadercolors={
			_Color={colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1}
		},
		textures={
			_Cube={
				front = "clouds.png",
				left = "clouds.png",
				right = "clouds.png",
				back = "clouds.png",
				top = "clouds.png",
				bottom = "clouds.png"
			},
			_MainTex="White.png"
		},
		height = 0,
	   	float_on_water = false,
		scale = {1,1,1}
		},
		
	{
		mesh = "Color.obj",
		shader = "MatCap/Vertex/PlainBright",
		shadersettings = fif(hifi, {_Brightness=2.0}, {_Brightness=3.5}),
		texture = "White.png",
	    	height = 0,
	   	float_on_water = false,
		scale = {1,1,1}
	}),
	greyblocks={
		mesh = "Block.obj",		
		shader = "MatCap/Vertex/PlainBright",
		shadersettings = fif(hifi, {_Brightness=2.0}, {_Brightness=3.5}),
		textures = {_MainTex="White.png", _MatCap=fif(randgrey>1,"matcapchrome.jpg","rainbow.png")},
		shadercolors= {_Color=fif(randgrey<3,{255,255,255},{colorsource="highwayinverted", scaletype="intensity", minscaler=2, maxscaler=2.5})}
		},
	powerups={
		whiteblock={
			mesh = "99.obj",
			shader = "MatCap/Vertex/PlainBright",
			shadersettings = fif(hifi, {_Brightness=2.0}, {_Brightness=3.5}),
			texture = "White.png",
			scale = {1,1,1},
			shadercolors = {255,255,255}
		},
		ghost=fif(randgrey==2,{
		mesh = "99.obj",
		shader = "GlassBumpDistort_AddReflection",
		shadersettings ={
			_ReflectMultiply = .5,
			_FresnelPower = 3.5, -- 1.36,
			_Brightness = 3
		},
		colorMode="highway",
		Color={colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1},
		shadercolors={
			_Color={colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1}
		},
		textures={
			_Cube={
				front = "clouds.png",
				left = "clouds.png",
				right = "clouds.png",
				back = "clouds.png",
				top = "clouds.png",
				bottom = "clouds.png"
			},
			_MainTex="White.png"
		},
		height = 0,
	   	float_on_water = false,
		scale = {1,1,1}
		},{
			mesh = "99.obj",
			shader = "MatCap/Vertex/PlainBright",
			shadersettings = fif(hifi, {_Brightness=2.0}, {_Brightness=3.5}),
			texture = "White.png",
			scale = {1,1,1},
			shadercolors = {_Color="highway"}
		}),
		powerpellet=fif(randgrey==2,{
		mesh = "999.obj",
		shader = "GlassBumpDistort_AddReflection",
		shadersettings ={
			_ReflectMultiply = .5,
			_FresnelPower = 3.5, -- 1.36,
			_Brightness = 3
		},
		colorMode="highway",
		Color={colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1},
		shadercolors={
			_Color={colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1}
		},
		textures={
			_Cube={
				front = "clouds.png",
				left = "clouds.png",
				right = "clouds.png",
				back = "clouds.png",
				top = "clouds.png",
				bottom = "clouds.png"
			},
			_MainTex="White.png"
		},
		height = 0,
	   	float_on_water = false,
		--scale = {1.5,1.5,1.5}
		},{
			mesh = "999.obj",
			shader = "MatCap/Vertex/PlainBright",
			shadersettings = fif(hifi, {_Brightness=2.0}, {_Brightness=3.5}),
			texture = "White.png",
			--scale = {2,2,2},
			shadercolors = {_Color="highway"}
		})
	}
}

if jumping then
	SetPlayer{
		cameramode = "first_jumpthird",
		camfirst={
			pos={0,2.7,-3.50475},
			rot={20.49113,0,0},
			strafefactor = 1
		},
		camthird={
			pos={0,3.5,-3.50475},
			rot={20.49113,0,0},
			strafefactor = 0.75,
			pos2={0,3.6,-3.50475},
			rot2={20.49113,0,0},
			strafefactorFar = 1},
		surfer={
			use_water_rooster = false,
			arms={
				shader="RimLightHatchedSurfer",
				shadercolors={_Color={colorsource="highway", scaletype="intensity", minscaler=3, maxscaler=6, param="_Threshold", paramMin=2, paramMax=2},_RimColor={colorsource="highwayinverted", scaletype="intensity", minscaler=3, maxscaler=6, param="_Threshold", paramMin=2, paramMax=2}},
				texture="FullLeftArm_1024_wAO.png"
			},
			board={
				shader="RimLightHatchedSurferExternal",
				renderqueue=3999,
				shadercolors={_Color={colorsource="highway", scaletype="intensity", minscaler=5, maxscaler=5},_RimColor={0,0,0}},
				shadersettings={_Threshold=11},
				texture="board_internalOutline.png"
			},
			body={
				shader="RimLightHatchedSurferExternal",
				renderqueue=3000,
				shadercolors={_Color={colorsource="highway", scaletype="intensity", minscaler=3, maxscaler=3},_RimColor={0,0,0}},
				shadersettings={_Threshold=1.7},
				texture="robot_HighContrast.png"

			}
		}
	}
else
	SetPlayer{
		cameramode = "third",
		camfirst={
			pos={0,1.84,-0.8},
			rot={20,0,0}},
		camthird={
			pos={0,4,-1},
			rot={30,0,0},
			strafefactorFar = .75,
			pos2={0,6,-3},
			rot2={40,0,0},
			strafefactorFar = 1,
			transitionspeed = 1,
			puzzleoffset=-0.65,
			puzzleoffset2=-1.5},
		vehicle={
			min_hover_height= 0.23,
			max_hover_height = 0.8,
			use_water_rooster = false,
            smooth_tilting = true,
			reflect = true,
            smooth_tilting_speed = 10,
            smooth_tilting_max_offset = -20,
			pos={x=0,y=0,z=0},
			mesh="Ship.obj",
			shader="VertexColorUnlitTintedAdd",
			layer = 14,
			renderqueue = 2000,
			shadercolors={
				_Color = {colorsource="highwayinverted", scaletype="intensity", minscaler=1, maxscaler=1.5}},
			texture="White.png",
			scale = {x=1,y=1,z=1},
			thrusters = {crossSectionShape={{-.35,-.35,0},{-.5,0,0},{-.35,.35,0},{0,.5,0},{.35,.35,0},{.5,0,0},{.35,-.35,0}},
						perShapeNodeColorScalers={.5,1,1,1,1,1,.5},
						shader="VertexColorUnlitTintedAdd",
						layer = 14,
						renderqueue = 3999,
						colorscaler = 2,
						extrusions=22,
						stretch=-0.222,
						updateseconds = 0.025,
						instances={
							{pos={0,0,1},rot={0,0,58.713},scale={.7,.7,.7}}
						}}
		}
	}
end

track = GetTrack()--get the track data from the game engine
do
		local A = track[1].pos
		local min={x=A.x, y=A.y, z=A.z}
		local max={x=A.x, y=A.y, z=A.z}
		for i=2,#track do
			local N = track[i].pos
			for key, value in pairs(max) do
				if N[key] > max[key] then max[key] = N[key] end
			end
			for key, value in pairs(max) do
				if N[key] < min[key] then min[key] = N[key] end
			end
		end
		track_bounds = {min=min, max=max}
	end

	track_bounds.center = {
		x=(track_bounds.min.x + track_bounds.max.x) / 2,
		y=(track_bounds.min.y + track_bounds.max.y) / 2,
		z=(track_bounds.min.z + track_bounds.max.z) / 2
	}
if randgrey>2 then
SetTrackColors(randomhuecolors())
elseif randgrey==2 then
SetTrackColors{ --enter any number of colors here. The track will use the first ones on less intense sections and interpolate all the way to the last one on the most intense sections of the track
	{r=100, g=0, b=155},
	{r=0, g=0, b=255},
    {r=0, g=255, b=255},
    {r=0, g=255, b=0},
    {r=255, g=255, b=0},
	{r=255, g=0, b=0},
	{r=100, g=0, b=155},
	{r=0, g=0, b=255},
    {r=0, g=255, b=255},
    {r=0, g=255, b=0},
    {r=255, g=255, b=0},
	{r=255, g=0, b=0}
}
else
SetTrackColors{
    {r=50, g=50, b=50},
    {r=205, g=205, b=205}
}
end
randomspace = math.random(0,15)
if randomspace<9 then
r19=math.random(0,100)
if randgrey~=1 then CreateObject{
	name="lvf",
	railoffset=0,
	--floatonwaterwaves = false,
	gameobject={
		pos={x=0,y=0,z=0},
		mesh="222.obj",
		--layer=10,
		shader=fif(r19>10,"VertexColorUnlitTintedMultiplyNoDepthWrite","VertexColorUnlitTintedAddSmoothQuarter"),
			shadercolors={
				_Color = {colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1},
				},
			texture="White.png",
		Color={colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1},
		scale = {x=1000,y=1000,z=1000}
	}
}
end
SetSkybox{
color = {colorsource="highway", staticalpha=0},
	skysphere="s" .. randomspace .. ".png",
}
if randomspace==8 then
Nodes = {}
RotationSpeeds = {}
Nodes[#Nodes+1] = #track
RotationSpeeds[#RotationSpeeds+1] = {2,1,2}
CreateObject{
			name="Grid",
			visible=false,
			gameobject={
				mesh="123.obj",
				transform={
					pos={track_bounds.center.x, track_bounds.center.y, track_bounds.center.z},
				},
				
		shader = "MatCap/Vertex/PlainBright",
		shadersettings = fif(hifi, {_Brightness=2.0}, {_Brightness=3.5}),
		textures = {_MainTex="White.png", _MatCap="matcapchrome.jpg"},
		shadercolors={
			_Color={colorsource="highway", scaletype="intensity", minscaler=1.1, maxscaler=1.1},
		},
				}
			}
BatchRenderEveryFrame{
	prefabName="Grid", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
	locations=Nodes,
	rotateWithTrack=false,
	maxDistanceShown=40000000,
	rotationspeeds = RotationSpeeds,
	testAndHideIfCollideWithTrack=false --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
}
end
if randomspace~=6 and randomspace~=7 and randomspace~=8 then 
radialBlurEffect = BuildMaterial{ -- background radial blur (seen mostly on star air debris trails)
		shader="PostRadialBlur",
		shadersettings={_Amount=.02, _Center={.5,.5,0}}
	}

	AddPostEffect{
		depth="background",
		material = radialBlurEffect
	}
end
elseif randomspace==11 then
CreateObject{--skywires, the red lines in the sky. A railed object is attached to the track and moves along it with the player.
	railoffset=0,
	floatonwaterwaves = false,
	gameobject={
		name="scriptSkyWires",
		pos={x=0,y=0,z=0},
		mesh="skywires.obj",
		
		shader="VertexColorUnlitTintedAdd",
		shadercolors={
			_Color="highway"
		},
		scale = {x=1,y=1,z=1},
		lookat = "end"
	}
}

elseif randomspace==12 then

SetSkybox{
	skyscreen = "Skyscreen/TheGrid"
}
	
	local scale = 300000 + math.max(
			track_bounds.max.x - track_bounds.center.x,
			track_bounds.max.z - track_bounds.center.z
		)
CreateObject{
			name="Grid",
			gameobject={
				mesh="quad.obj",
				texture="2.jpg",
				texturewrap = "clamp",
				scale={scale,scale,scale},
				transform={
					pos={track_bounds.center.x, math.max(track_bounds.max.y + 1000, 15000), track_bounds.center.z},
					rot={90,0,0}
				},
				shader="VertexColorUnlitTintedAddSmooth",
				layer=13, -- don't glow. in additive mode (above) glowing makes it reveal the pillars of light used to accent glow and skywires.
				shadercolors={
					_Color = {colorsource=fif(randgrey==2,"highwayinverted","highway"), scaletype="intensity", minscaler=1, maxscaler=6}
				}
			}
		}
elseif randomspace==13 then
SetSkybox{
skyscreen = "Skyscreen/TheGridSky"
}
elseif randomspace==14 then
do
		local A = track[1].pos
		local min={x=A.x, y=A.y, z=A.z}
		local max={x=A.x, y=A.y, z=A.z}
		for i=2,#track do
			local N = track[i].pos
			for key, value in pairs(max) do
				if N[key] > max[key] then max[key] = N[key] end
			end
			for key, value in pairs(max) do
				if N[key] < min[key] then min[key] = N[key] end
			end
		end
		track_bounds = {min=min, max=max}
	end

	track_bounds.center = {
		x=(track_bounds.min.x + track_bounds.max.x) / 2,
		y=(track_bounds.min.y + track_bounds.max.y) / 2,
		z=(track_bounds.min.z + track_bounds.max.z) / 2
	}
	local scale = 300000 + math.max(
			track_bounds.max.x - track_bounds.center.x,
			track_bounds.max.z - track_bounds.center.z
		)
CreateObject{
			name="Grid",
			gameobject={
				mesh="quad.obj",
				texture="2.jpg",
				texturewrap = "clamp",
				scale={scale,scale,scale},
				transform={
					pos={track_bounds.center.x, math.max(track_bounds.max.y + 1000, 15000), track_bounds.center.z},
					rot={90,0,0}
				},
				shader="VertexColorUnlitTintedAddSmooth",
				layer=13, -- don't glow. in additive mode (above) glowing makes it reveal the pillars of light used to accent glow and skywires.
				shadercolors={
					_Color = {colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=6}
				}
			}
		}
CreateObject{
			name="Grid2",
			gameobject={
				mesh="quad.obj",
				texture="2.jpg",
				texturewrap = "clamp",
				scale={scale,scale,scale},
				transform={
					pos={track_bounds.center.x, math.min(track_bounds.min.y - 1000, -15000), track_bounds.center.z},
					rot={-90,0,0}
				},
				shader="VertexColorUnlitTintedAddSmooth",
				layer=13, -- don't glow. in additive mode (above) glowing makes it reveal the pillars of light used to accent glow and skywires.
				shadercolors={
					_Color = {colorsource=fif(randgrey==2,"highwayinverted","highway"), scaletype="intensity", minscaler=1, maxscaler=6}
				}
			}
		}
elseif randomspace==9 then
CreateObject{--skywires, the red lines in the sky. A railed object is attached to the track and moves along it with the player.
	railoffset=0,
	floatonwaterwaves = false,
	gameobject={
		name="scriptSkyWires",
		pos={x=0,y=0,z=0},
		mesh="123.obj",
		
		shader="VertexColorUnlitTintedAddSmoothQuarter",
		shadercolors={
			_Color="highway"
		},
		scale = {x=1,y=1,z=1},
		lookat = "end"
	}
}

elseif randomspace==10 then
do
		local A = track[1].pos
		local min={x=A.x, y=A.y, z=A.z}
		local max={x=A.x, y=A.y, z=A.z}
		for i=2,#track do
			local N = track[i].pos
			for key, value in pairs(max) do
				if N[key] > max[key] then max[key] = N[key] end
			end
			for key, value in pairs(max) do
				if N[key] < min[key] then min[key] = N[key] end
			end
		end
		track_bounds = {min=min, max=max}
	end

	track_bounds.center = {
		x=(track_bounds.min.x + track_bounds.max.x) / 2,
		y=(track_bounds.min.y + track_bounds.max.y) / 2,
		z=(track_bounds.min.z + track_bounds.max.z) / 2
	}
	local scale = 300000 + math.max(
			track_bounds.max.x - track_bounds.center.x,
			track_bounds.max.z - track_bounds.center.z
		)
CreateObject{
			name="Grid2",
			gameobject={
				mesh="quad.obj",
				texture="2.jpg",
				texturewrap = "clamp",
				scale={scale,scale,scale},
				transform={
					pos={track_bounds.center.x, track_bounds.min.y - 10, track_bounds.center.z},
					rot={-90,0,0}
				},
				shader="VertexColorUnlitTintedAddSmooth",
				layer=13, -- don't glow. in additive mode (above) glowing makes it reveal the pillars of light used to accent glow and skywires.
				shadercolors={
					_Color = {colorsource=fif(randgrey==2,"highwayinverted","highway"), scaletype="intensity", minscaler=1, maxscaler=6}
				}
			}
		}
SetSkybox{
skyscreen = "Skyscreen/TheGridAdditive"
	}
	else
do
		local A = track[1].pos
		local min={x=A.x, y=A.y, z=A.z}
		local max={x=A.x, y=A.y, z=A.z}
		for i=2,#track do
			local N = track[i].pos
			for key, value in pairs(max) do
				if N[key] > max[key] then max[key] = N[key] end
			end
			for key, value in pairs(max) do
				if N[key] < min[key] then min[key] = N[key] end
			end
		end
		track_bounds = {min=min, max=max}
	end

	track_bounds.center = {
		x=(track_bounds.min.x + track_bounds.max.x) / 2,
		y=(track_bounds.min.y + track_bounds.max.y) / 2,
		z=(track_bounds.min.z + track_bounds.max.z) / 2
	}
	local scale = 300000 + math.max(
			track_bounds.max.x - track_bounds.center.x,
			track_bounds.max.z - track_bounds.center.z
		)
CreateObject{
			name="Grid",
			gameobject={
				mesh="quad.obj",
				texture="2.jpg",
				texturewrap = "clamp",
				scale={scale,scale,scale},
				transform={
					pos={math.max(track_bounds.max.x+ 1000, 15000), track_bounds.center.y, track_bounds.center.z},
					rot={0,-90,0}
				},
				shader="VertexColorUnlitTintedAddSmooth",
				layer=13, -- don't glow. in additive mode (above) glowing makes it reveal the pillars of light used to accent glow and skywires.
				shadercolors={
					_Color = {colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=6}
				}
			}
		}
CreateObject{
			name="Grid2",
			gameobject={
				mesh="quad.obj",
				texture="2.jpg",
				texturewrap = "clamp",
				scale={scale,scale,scale},
				transform={
					pos={math.min(track_bounds.min.x-1000, -15000), track_bounds.center.y, track_bounds.center.z},
					rot={0,90,0}
				},
				shader="VertexColorUnlitTintedAddSmooth",
				layer=13, -- don't glow. in additive mode (above) glowing makes it reveal the pillars of light used to accent glow and skywires.
				shadercolors={
					_Color = {colorsource=fif(randgrey==2,"highwayinverted","highway"), scaletype="intensity", minscaler=1, maxscaler=6}
				}
			}
		}
end

SetBlockFlashes{
	texture="hit2.jpg",
	sizescaler = .5,
	sizescaler_missed = 0
}


blockColors = {}
if skinvars.colorcount < 5 then
	blockColors ={
	    hsv(270,.95,.75), --purple
	    hsv(210,.95,.75),
	    --{r=12, g=130, b=240}, --lightblue
	    hsv(60,.95,.75),
		hsv(0,.95,.75),
	}
else
	blockColors={
	    hsv(270,.95,.75),
	    hsv(210,.95,.75),
	    hsv(120,.95,.75),
	    hsv(60,.95,.75),
		hsv(0,.95,.75)
	}
end
SetBlockColors(blockColors)

if ispuzzle then
	CreateLight{
		type= "directional",
		railoffset = -1,
		range = 10,
		intensity = 1,
		transform = {
			position={0,2,0}, rotation={.4,346.2,0}
		},
		color={255,255,255}
	}
end


SetRings{ --setup the tracks tunnel rings. the airmaterial is the tunnel used when you're up in a jump
        material = BuildMaterial{
                texture="PlainRing_1024.png",
                shader="VertexColorUnlitTintedAddSmooth",
        },
        layer = 13, -- on layer13, these objects won't be part of the glow effect
        size = 60,
        percentringed=.25,--ifhifi(2,.01),-- .2,
		airtexture="transparent.png",
		airshader="VertexColorUnlitTintedAddSmooth",
		airsize=16
}
if jumping then wakeHeight=2 else wakeHeight = .5 end
r27=math.random(0,100)
SetWake{ --setup the spray coming from the two pulling "boats"
	height = wakeHeight,
	fallrate = 0.95,
	shader = fif(jumping, "VertexColorUnlitTintedAddSmooth", "VertexColorUnlitTintedAddSmoothQuarter"),
	layer = fif(jumping, 11, 13), -- looks better not rendered in background when water surface is not type 2
	bottomcolor = "highwayinverted",
	topcolor = fif(r27<50,"highwayinverted",{r=0,g=0,b=0})
}

CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="BuildingCloneMe",
	gameobject={
		pos={x=0,y=0,z=0},
		mesh="Building.obj",
		shader="VertexColorUnlitTintedAdd",
		shadercolors={
			_Color=fif(randgrey==2,"highwayinverted","highway")
		},
	}
}




if buildingNodes == nil then
	buildingNodes = {} --the track is made of nodes, each one with a position and rotation. This table will hold the indices of track nods that should have a skyscraper rendered at them (with some offset)
	offsets = {}

	for i=1,#track do
		if i%80==0 then
			buildingNodes[#buildingNodes+1] = i
			local xOffset = 150 + 1650*math.random()
			if math.random() > 0.5 then xOffset = xOffset * -1 end
			offsets[#offsets+1] = {xOffset,-100,0}
		end
	end

	BatchRenderEveryFrame{prefabName="BuildingCloneMe", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
							locations=buildingNodes,
                    		rotateWithTrack=true,
                    		maxShown=10,
                    		maxDistanceShown=20000,
							offsets=offsets,
							collisionLayer = 1,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
							testAndHideIfCollideWithTrack=true --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
						}
end

CreateObject{
	name="EndCookie",
	tracknode="end",
	gameobject={
		pos={x=0,y=0,z=0},
		scale={60,60,60},
		mesh="EndBox.obj",
		shader="VertexColorUnlitTintedAdd",
		shadercolors={
			_Color=fif(randgrey==2,{180,180,180},"highwayinverted")
		}
	}
}


	local laneDividers = skinvars["lanedividers"]
	for i=1,#laneDividers do
		CreateRail{ -- lane line
			positionOffset={
				x=laneDividers[i],
				y=0.1},
			crossSectionShape={
				{x=-.07,y=0},
				{x=.07,y=0}},
			perShapeNodeColorScalers={
				1,
				1},
			colorMode="highway",
			color = {r=255,g=255,b=255},
			flatten=false,
			--nodeskip = 2,
			wrapnodeshape = false,
			shader="VertexColorUnlitTinted"
			
		}
	end
if not doublevision and not casual and not guitarhero then
CreateRail{ -- lane line
			positionOffset={
				x=-4.75,
				y=0.1},
			crossSectionShape={
				{x=-.07,y=0},
				{x=.07,y=0}},
			perShapeNodeColorScalers={
				1,
				1},
			colorMode="highway",
			color = {r=255,g=255,b=255},
			flatten=false,
			--nodeskip = 2,
			wrapnodeshape = false,
			shader="VertexColorUnlitTinted"
			
		}
		CreateRail{ -- lane line
			positionOffset={
				x=4.75,
				y=0.1},
			crossSectionShape={
				{x=-.07,y=0},
				{x=.07,y=0}},
			perShapeNodeColorScalers={
				1,
				1},
			colorMode="highway",
			color = {r=255,g=255,b=255},
			flatten=false,
			--nodeskip = 2,
			wrapnodeshape = false,
			shader="VertexColorUnlitTinted"
			
		}
		CreateRail{--subroad left
		positionOffset={
			x=0,
			y=0},
		crossSectionShape={
			{x=-4.75,y=0},
			{x=-1.5,y=0}},
		colorMode="highway",
		layer=13,
		wrapnodeshape = false,
		fullfuture = true,
		color = {r=255,g=255,b=255,a=255},
		flatten=false,
		shader="VertexColorUnlitTintedAlpha",
		shadercolors={_Color={r=30,g=30,b=30,a=245}}

	}

	CreateRail{--subroad right
		positionOffset={
			x=0,
			y=0},
		crossSectionShape={
			{x=1.5,y=0},
			{x=4.75,y=0}},
		colorMode="highway",
		layer=13,
		wrapnodeshape = false,
		fullfuture = true,
		color = {r=255,g=255,b=255,a=255},
		flatten=false,
		shader="VertexColorUnlitTintedAlpha",
		shadercolors={_Color={r=30,g=30,b=30,a=245}}
		
	}
		CreateRail{--subroad center
		positionOffset={
			x=0,
			y=0},
		crossSectionShape={
			{x=-1.5,y=0},
			{x=1.5,y=0}},
		colorMode="highway",
		layer=13,
		wrapnodeshape = false,
		fullfuture = true,
		color = {r=255,g=255,b=255,a=255},
		flatten=false,

		--texture="4.png",
		shader="VertexColorUnlitTintedAlpha",
		shadercolors={_Color={r=45,g=45,b=45,a=180}}
	}
CreateRail{--road surface
		positionOffset={
			x=0,
			y=-.2},
		crossSectionShape={
			{x=-trackWidth-5,y=0},
			{x=-4.75,y=0}},

	colorMode="highway",
		layer=13,
		wrapnodeshape = false,
		fullfuture = true,
		color = {r=255,g=255,b=255,a=255},
		flatten=false,

		--texture="4.png",
		shader="VertexColorUnlitTintedAlpha",
		shadercolors={_Color={r=45,g=45,b=45,a=180}}
	}
	CreateRail{--road surface
		positionOffset={
			x=0,
			y=-.2},
		crossSectionShape={
			{x=4.75,y=0},
			{x=trackWidth+5,y=0}},
		colorMode="highway",
		layer=13,
		wrapnodeshape = false,
		fullfuture = true,
		color = {r=255,g=255,b=255,a=255},
		flatten=false,

		--texture="4.png",
		shader="VertexColorUnlitTintedAlpha",
		shadercolors={_Color={r=45,g=45,b=45,a=180}}
	}
	else
	CreateRail{
		positionOffset={
			x=0,
			y=-.2},
		crossSectionShape={
			{x=-trackWidth-5,y=0},
			{x=trackWidth+5,y=0}},
		colorMode="highway",
		layer=13,
		wrapnodeshape = false,
		fullfuture = true,
		color = {r=255,g=255,b=255,a=255},
		flatten=false,
		shader="VertexColorUnlitTintedAlpha",
		shadercolors={_Color={r=30,g=30,b=30,a=245}}
		
	}
	end
CreateRail{--left rail
	positionOffset={
		x=-trackWidth - 5,
		y=0},
	crossSectionShape={
		{x=-.65,y=0.5},
		{x=.3,y=0.5},
		{x=.3,y=-3},
		{x=-.65,y=-3}},
	perShapeNodeColorScalers={
		.5,
		1,
		0,
		0},
	colorMode="highway",
	color = {r=255,g=255,b=255},
	flatten=false,
	fullfuture = true,
	layer = 13,
	--texture="cliffRails.png",
	shader="VertexColorUnlitTintedAdd",
	shadercolors={_Color={r=0.33,g=0.33,b=0.33}},
	shadersettings={_StartDistance=3.92, _FullDistance=11.9}
}

CreateRail{--right rail
	positionOffset={
		x=trackWidth + 5,
		y=0},
	crossSectionShape={
		{x=-.65,y=0.5},
		{x=.3,y=0.5},
		{x=.3,y=-3},
		{x=-.65,y=-3}},
	perShapeNodeColorScalers={
		.5,
		1,
		0,
		0},
	colorMode="highway",
	color = {r=255,g=255,b=255},
	flatten=false,
	layer = 13,
	fullfuture = true,
	--texture="cliffRails.png",
	shader="VertexColorUnlitTintedAdd",
	shadercolors={_Color={r=0.33,g=0.33,b=0.33}},
	shadersettings={_StartDistance=3.92, _FullDistance=11.9}
}
CreateRepeatedMeshRail{
    ahead_renderdist = 1000,
    behind_renderdist = 70,
    spacing = 750, -- default is 0, for a seamless repeated mesh track. spacing can also be accomplished in the OBJ file by not starting at right at the origin, but further down the positive z axis
    colorMode = "none",

    buildlive = true, -- if live mode is not used it will take longer to load and use more memory, but it will run better during gameplay
    maxmeshesperbatch = 4, -- when in live mode, this is the number of mesh copies that can be shaped to the track in a single frame without a hiccup
    calculatenormals = false, --set true if using lighting
    
	gameobject={
		name="meshrailproto1",
		shadowcaster = false,
		shadowreceiver = false,
		mesh="Arch.obj",
		shader="VertexColorUnlitTintedAdd",
		shadercolors={
			_Color={colorsource=fif(randgrey==2,"highwayinverted","highway"), scaletype="intensity", minscaler=1, maxscaler=1}
		},
		--texture="White.png"
	}
}
